Package ch.qos.logback.core.joran.spi

## Interface RuleStore

All Known Implementing Classes:
  `SimpleRuleStore`

    public interface RuleStore

As its name indicates, a RuleStore contains 2-tuples consists of a ElementSelector and an Action.

As a joran configurator goes through the elements in a document, it asks the rule store whether there are rules matching the current pattern by invoking the `matchActions(ElementPath)` method.

Author:
  Ceki Gülcü

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `addRule​(ElementSelector elementSelector, Action action)` Add a new rule, given by a pattern and an action instance.
`void` `addRule​(ElementSelector elementSelector, java.lang.String actionClassStr)` Add a new rule, given by a pattern and a action class (String).
`java.util.List<Action>` `matchActions​(ElementPath elementPath)` Return a list of actions matching a pattern.

### Method Detail

#### addRule

    void addRule​(ElementSelector elementSelector,
                 java.lang.String actionClassStr)
          throws java.lang.ClassNotFoundException

Add a new rule, given by a pattern and a action class (String).

Parameters:
  `elementSelector` -
  `actionClassStr` -
Throws:
  `java.lang.ClassNotFoundException`

#### addRule

    void addRule​(ElementSelector elementSelector,
                 Action action)

Add a new rule, given by a pattern and an action instance.

Parameters:
  `elementSelector` -
  `action` -

#### matchActions

    java.util.List<Action> matchActions​(ElementPath elementPath)

Return a list of actions matching a pattern.

Parameters:
  `elementPath` - the path to match for
Returns:
  list of matching actions